type GetFn<T> = (state: T) => React.ReactNode;
type PrevState<T> = (prevState: T) => T;

interface State<T> {
  Ctx: (fn: GetFn<T>) => React.ReactNode;
  Put: (nextState: T | PrevState<T>) => void;
  Val: <S = any>(
    selector: (state: T) => S
  ) => (fn: GetFn<S>) => React.ReactNode;
  Auto: <S = any>(
    selector: (state: T) => S
  ) => (fn: GetFn<S>) => React.ReactNode;
}

export function init(initial: T = {}): State<T>;
